//
//  bctypes.h
//
//  Created by Ken Miyachi on 11/12/07.
//  Copyright 2011 B-Core.Inc . All rights reserved.
//

#ifndef _bc_types_h
#define _bc_types_h 1


#ifdef __cplusplus
extern "C" {
#endif

//CB decoder param : use image correction
#define MW_CB_DECODER_USE_IMAGE_CORRECTION    0   
#define MW_CB_DECODER_NONUSE_IMAGE_CORRECTION 1
    
//CB decode param : error correction level
#define MW_CB_CODING_CORRECTION_LEVEL_0 0
#define	MW_CB_CODING_CORRECTION_LEVEL_1 1
#define	MW_CB_CODING_CORRECTION_LEVEL_2 2

//Error Code
//CB coding error       
#define	MW_CB_CODING_ERROR_SCHEME  -1
#define	MW_CB_CODING_ERROR_INVALID  -2
#define	MW_CB_CODING_ERROR_SHORT  -3
#define	MW_CB_CODING_ERROR_LONG  -4
#define	MW_CB_CODING_ERROR_CHECK  -5
#define MW_CB_CODING_ERROR_CORRECTION_LEVEL  -6	    
//CB quantizer error     
#define MW_CB_QUIET_ERROR_INVALID_INPUT_IMAGE -7
#define MW_CB_QUIET_ERROR_CLUSTER_FAILED -8
#define MW_CB_QUIET_ERROR_NON_SUPPORT_QUANTIZER_BIN -9    
//CB allocater pointer error    
#define MW_CB_ALLOCATER_ERROR_INVALID_POINTER -10
    
#ifdef __cplusplus
}
#endif


#ifdef __cplusplus
namespace mw { 
namespace cb {

//CB decoder param : use image correction
typedef enum IMAGE_CORRECTION{
    DECODER_USE_IMAGE_CORRECTION = MW_CB_DECODER_USE_IMAGE_CORRECTION,  
    DECODER_NONUSE_IMAGE_CORRECTION = MW_CB_DECODER_NONUSE_IMAGE_CORRECTION    
}IMAGE_CORRECTION;

//CB decoder param : error correction level           
typedef enum EC_LEVEL{
        CODING_LD5_C15_CORRECTION_LEVEL_0 = MW_CB_CODING_CORRECTION_LEVEL_0,
        CODING_LD5_C15_CORRECTION_LEVEL_1 = MW_CB_CODING_CORRECTION_LEVEL_1,
        CODING_LD5_C15_CORRECTION_LEVEL_2 = MW_CB_CODING_CORRECTION_LEVEL_2
}EC_LEVEL;

//Error Code
typedef enum ERROR_CODE{
    //CB data decode error       
	CODING_ERROR_SCHEME = MW_CB_CODING_ERROR_SCHEME,
	CODING_ERROR_INVALID = MW_CB_CODING_ERROR_INVALID,
	CODING_ERROR_SHORT = MW_CB_CODING_ERROR_SHORT,
	CODING_ERROR_LONG = MW_CB_CODING_ERROR_LONG,
	CODING_ERROR_CHECK = MW_CB_CODING_ERROR_CHECK,
    CODING_ERROR_CORRECTION_LEVEL = MW_CB_CODING_ERROR_CORRECTION_LEVEL,	
    //CB Quantizer error code    
    QUIET_ERROR_INVALID_INPUT_IMAGE = MW_CB_QUIET_ERROR_INVALID_INPUT_IMAGE,
    QUIET_ERROR_CLUSTER_FAILED = MW_CB_QUIET_ERROR_CLUSTER_FAILED,
    QUIET_ERROR_NON_SUPPORT_QUANTIZER_BIN = MW_CB_QUIET_ERROR_NON_SUPPORT_QUANTIZER_BIN,
    //CB Allocation Func Pointer error        
    ALLOCATER_ERROR_INVALID_POINTER = MW_CB_ALLOCATER_ERROR_INVALID_POINTER
}ERROR_CODE;

}
}
#endif 

#endif
